module comp(a, b, out);
   parameter width = 5,prop = 3;  
   input [width-1:0] a;   // Operand to compare.
   input [width-1:0] b;   // Operand to compare.
   output 	     out; // Result of comparison: 1 => equality, 0 => inequality.
   
   wire 	     w1,w2,w3,w4,w5,w6,w7;
   
   xor #(prop) (w1,a[4],b[4]);
   xor #(prop) (w2,a[3],b[3]);
   xor #(prop) (w3,a[2],b[2]);
   xor #(prop) (w4,a[1],b[1]);
   xor #(prop) (w5,a[0],b[0]);
   
   nor #(prop) (w6,w1,w2,w3);
   nor #(prop) (w7,w4,w5);
   
   and #(prop) (out,w6,w7);   
endmodule // comp






